#include "sockets.h"

int main(void)
{
	int disabled=0;
	int sockfd,sockfd2;
	struct hostent *he;
	struct line table[NUM_NODES];
	struct sockaddr_in my_addr;	// my address information
	struct sockaddr_in their_addr; // connector's address information
	socklen_t addr_len;
	int numbytes,numbytes2;
	char *myip;
	char aux[16];
	char path[20]="/MAYA/server/client";//Where's the client file?
	char change_essid[24]="/MAYA/cparam/essid.sh";
	char change_channel[26]="/MAYA/cparam/channel.sh";
	char change_WEP[22]="/MAYA/cparam/WEP.sh";
	char change_name[23]="/MAYA/cparam/name.sh";
	char change_password[27]="/MAYA/cparam/password.sh";
	char *ins;
	int one=1;
	int newpacket=0;
	char *instruction;
	int num_seq=1;
	int i,j,HITequal;
	char HIT[41];
	char CPHIT[41];
	char MYHIT[41];


	char rec_broadcast_ip[16];	
	char rec_source_ip[16];
	char rec_param[20];
	char rec_value[50];
	int rec_num_seq;
	char rec_num_seqs[10];
	int rec_an;
	char rec_ans[10];
	char rec_HIT[42];

        RSA *key;
        FILE *pub_keyfile = NULL;
        FILE *HIT_file = NULL;
        FILE *HIT_file2 = NULL;
        unsigned char *tmp = NULL;
        unsigned char array[356] = {0};
	unsigned char unencrypted_data[200] = {0};
        encrypted_packet data;

////////////////////////////////////////////////////////////////////////////////


	//We get our wlan IP
	get_wlan_ip(aux);	
	myip=strtok(aux,"\n");
	
	//Init. table
	for(i=0;i<NUM_NODES;i++){
	strcpy(table[i].ip,"");
	table[i].num_seq=0;
	}

	/////SOCKET SENDER/////
	if ((sockfd2 = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}
	//Options for broadcast
	 if (setsockopt(sockfd2, SOL_SOCKET,  SO_REUSEADDR, (char *)&one,sizeof(one)) < 0) {
   	 perror("setsockopt() failed");
   	 exit(1);
  	}

  	if (setsockopt(sockfd2, SOL_SOCKET,  SO_BROADCAST, (char *)&one,sizeof(one)) < 0) {
   	 perror("setsockopt() failed");
   	 exit(1);
  	}

	my_addr.sin_family = AF_INET;		 // host byte order
	my_addr.sin_port = htons(PORT);	 // short, network byte order
	my_addr.sin_addr.s_addr = htonl(INADDR_ANY); // automatically fill with my IP
	memset(&(my_addr.sin_zero), '\0', 8); // zero the rest of the struct

	
	/////SOCKET LISTENER/////
	if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}
	//Options for broadcast
	 if (setsockopt(sockfd, SOL_SOCKET,  SO_REUSEADDR, (char *)&one,sizeof(one)) < 0) {
   	 perror("setsockopt() failed");
   	 exit(1);
  	}

  	if (setsockopt(sockfd, SOL_SOCKET,  SO_BROADCAST, (char *)&one,sizeof(one)) < 0) {
   	 perror("setsockopt() failed");
   	 exit(1);
  	}

	my_addr.sin_family = AF_INET;		 // host byte order
	my_addr.sin_port = htons(PORT);	 // short, network byte order
	my_addr.sin_addr.s_addr = htonl(INADDR_ANY); // automatically fill with my IP
	memset(&(my_addr.sin_zero), '\0', 8); // zero the rest of the struct

	if (bind(sockfd, (struct sockaddr *)&my_addr,
		sizeof(struct sockaddr)) == -1) {
		perror("bind");
		exit(1);
	}
	addr_len = sizeof(struct sockaddr);

	while (1){
	//We wait until we recieve a packet
	if ((numbytes = recvfrom(sockfd, array, 356 , 0,
		(struct sockaddr *)&their_addr, &addr_len)) == -1) {
		perror("recvfrom");
		exit(1);}

	//We get the unencrypted part of the packet
	j=0;
	for(i=257;i<356 && array[i]!='\0';i++){
		unencrypted_data[j]=array[i];
		j++;
	}
	unencrypted_data[j]='\0';
	
	sscanf(unencrypted_data,"%s %s %s %s",rec_num_seqs,rec_source_ip,rec_broadcast_ip,rec_HIT);
	rec_num_seq=atoi(rec_num_seqs);


	i=0;newpacket=0;
	while(i<NUM_NODES){
	//If we found the ip in the table and the sequence number is higher than the one we have...
	if(strcmp(table[i].ip,rec_source_ip)==0){
		if (rec_num_seq>table[i].num_seq) {
		table[i].num_seq=rec_num_seq;
		newpacket=1;//...is a new packet
		}
	break;
	}
	//If the ip source is new, we add it to the table...
	if(strcmp(table[i].ip,"")==0){
	strcpy(table[i].ip,rec_source_ip);
	table[i].num_seq=rec_num_seq;
	newpacket=1;//...and,also, is new
	break;
	}
	i++;
}	

	//We get our HIT and CP's HIT
	if((HIT_file = fopen("HIT", "r")) == NULL){
        fprintf(stderr, "fopen()\n");
        exit(EXIT_FAILURE);
	}
	fgets(MYHIT,41,HIT_file);
	if((HIT_file2 = fopen("CPHIT", "r")) == NULL){
        fprintf(stderr, "fopen()\n");
        exit(EXIT_FAILURE);
	}
	fgets(CPHIT,41,HIT_file2);
	

	//Only new packets
	if(newpacket==1){
		//If the packet is for me...
		if(strcmp(rec_HIT,MYHIT)==0){
			printf("got packet from %s\n",inet_ntoa(their_addr.sin_addr));
			printf("packet is %d bytes long\n",numbytes);
			if((pub_keyfile = fopen("CPpub.key", "r")) == NULL){
                		fprintf(stderr, "fopen()\n");
                		exit(EXIT_FAILURE);
			}
			
			//Decrypt the message
       			key=PEM_read_RSAPublicKey(pub_keyfile, NULL, NULL, NULL);
        		fclose(pub_keyfile); 
        		memset(&data, 0, sizeof(encrypted_packet));
        		RSA_public_decrypt(256, array, (unsigned char *)&data , key, RSA_PKCS1_PADDING);
        		RSA_free(key);
			sscanf (data.message,"%s %s %s",rec_param,rec_value,rec_ans);
			rec_an=atoi(rec_ans);


			//We send the acknowledgement...
			instruction=(char 	*)malloc(strlen(rec_param)+strlen(rec_source_ip)+strlen(rec_broadcast_ip)+strlen(rec_value)+strlen(path)+strlen(CPHIT)+2*sizeof(int)+8);

			sprintf(instruction,"%s %s %s %d %d %s %s %s", path, rec_param,rec_value,rec_an,num_seq,myip,rec_broadcast_ip,CPHIT);
			printf("%s\n",instruction);

			system(instruction);
			free(instruction);
	
			num_seq++;
			//Changing parameters...
			if (strcmp(rec_param,"disable")==0){
				//We execute the enable or disable script depending on the value
				if((strcmp(rec_value,"yes")==0) && (disabled!=1)){
					system("sh /MAYA/cparam/disable.sh");
					disabled=1;
				}
				else if ((strcmp(rec_value,"no")==0) && (disabled!=0)){
					
					system("sh /MAYA/cparam/enable.sh ");
					disabled=0;
				}
			}
			else if (strcmp(rec_param,"ESSID")==0){
				ins=(char *)malloc(strlen(change_essid)+strlen(rec_value)+1);
				sprintf(ins,"%s %s",change_essid,rec_value);
				system(ins);
				free(ins);
			}
			else if (strcmp(rec_param,"Channel")==0){
				ins=(char *)malloc(strlen(change_channel)+strlen(rec_value)+1);
				sprintf(ins,"%s %s",change_channel,rec_value);
				system(ins);
				free(ins);
			}
			else if (strcmp(rec_param,"WEP")==0){
				if(strcmp(rec_value,"OFF")==0){
					system("sh /MAYA/cparam/WEPdisable.sh");
				}
				else{
				ins=(char *)malloc(strlen(change_WEP)+strlen(rec_value)+1);
				sprintf(ins,"%s %s",change_WEP,rec_value);
				system(ins);
				free(ins);
					
				}

			}else if (strcmp(rec_param,"Name")==0){
				ins=(char *)malloc(strlen(change_name)+strlen(rec_value)+1);
				sprintf(ins,"%s %s",change_name,rec_value);
				system(ins);
				free(ins);
				}
			else if (strcmp(rec_param,"Password")==0){
				ins=(char *)malloc(strlen(change_password)+strlen(rec_value)+1);
				sprintf(ins,"%s %s",change_password,rec_value);
				system(ins);
				free(ins);
			}
			}
		//If  i have not sent the packet, i broadcast it...
		else if (strcmp(myip,inet_ntoa(their_addr.sin_addr))!=0){

		if ((he=gethostbyname(rec_broadcast_ip)) == NULL) {  // get the host info
			perror("gethostbyname");
			exit(1);
		}

		their_addr.sin_family = AF_INET;		 // host byte order
		their_addr.sin_port = htons(PORT);	 // short, network byte order
		their_addr.sin_addr = *((struct in_addr *)he->h_addr); // automatically fill with my IP
		memset(&(their_addr.sin_zero), '\0', 8); // zero the rest of the struct	

		if ((numbytes2 = sendto(sockfd2, array, 356, 0,
			 (struct sockaddr *)&their_addr, sizeof(struct sockaddr))) == -1) {
			perror("sendto");
			exit(1);
		}
		printf("sent %d bytes to %s\n", numbytes2, inet_ntoa(their_addr.sin_addr));	
		}


		printf("-----------------------------\n");
		printf("----------TABLE IP-----------\n");
		printf("-----------------------------\n");
		
		for(i=0;i<NUM_NODES;i++){
		printf("%d: %s\t%d\n",i,table[i].ip,table[i].num_seq);
		}

		}
	}
	close(sockfd);
	return 0;
}

