#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <sys/time.h>
#include <openssl/rsa.h>
#include <openssl/pem.h>

#define PORT 5022
#define NUM_NODES 10	
#define NUM_MAX_TRY 3
#define WAIT_TIME 2

typedef struct encrypted_packet encrypted_packet;	
struct encrypted_packet{
        char message[256];
};

struct line {
	char ip[16];
	int num_seq;
};

     int
     input_timeout (int filedes, unsigned int seconds)
     {
       fd_set set;
       struct timeval timeout;

       /* Initialize the file descriptor set. */
       FD_ZERO (&set);
       FD_SET (filedes, &set);

       /* Initialize the timeout data structure. */
       timeout.tv_sec = seconds;
       timeout.tv_usec = 0;

       /* select returns 0 if timeout, 1 if input available, -1 if error. */
       return (select (FD_SETSIZE,&set, NULL, NULL, &timeout));
     }

void get_wlan_ip(char *array){

	FILE *f1;
	//eth1 is the wireless interface on Linksys WRT54G, this value may change depending on the router
	system("/sbin/ifconfig wlan0 | grep Mask | cut -d \":\" -f 2 | cut -d \" \" -f 1 > /tmp/ip");
	f1=fopen("/tmp/ip","rt");
	fgets(array, 16, f1);
	fclose(f1);
}



