#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <time.h>

#define MAXDATASIZE 10000
#define MAXBUFFER 10000
#define MAX_CONNECTIONS 5

double return_time(){
	struct timeval tv;
	struct tm* ptm;
	char time_string[40];
	char time_millisec[45];
	int milliseconds;
	double milliseconds2;

	/* Obtain the time of day, and convert it to a tm struct. */
	gettimeofday (&tv, NULL);
	ptm = localtime (&tv.tv_sec);
	/* Format the date and time, down to a single second. */
	strftime (time_string, sizeof (time_string), "%s", ptm);
	/* Compute milliseconds from microseconds. */
	milliseconds = tv.tv_usec / 1000;
	/* Print the formatted time, in seconds, followed by a decimal point	
	and the milliseconds. */
	sprintf(time_millisec,"%s.%03ld", time_string, milliseconds);
	return atof(time_millisec);	
}

 int input_timeout (int filedes, unsigned int seconds){
       fd_set set;
       struct timeval timeout;

       /* Initialize the file descriptor set. */
       FD_ZERO (&set);
       FD_SET (filedes, &set);

       /* Initialize the timeout data structure. */
       timeout.tv_sec = seconds;
       timeout.tv_usec = 0;

       /* select returns 0 if timeout, 1 if input available, -1 if error. */
       return (select (FD_SETSIZE,&set, NULL, NULL, &timeout));
}

