#include "TcpFlow.h"
#define ARGS 3

int main(int argc, char *argv[]){
	// 1 -> IP destino
	// 2 -> lengthTrans
	
	int sockfd, port;
	struct sockaddr_in serv_addr;
	struct hostent *he;
	int sendThis, numbytes;
	char *message;
	int lengthTrans, fragment=1, secs;
	double start_time, current_time;
	
	if(argc <= ARGS){
		printf("use %s <IP> <Port> <Bytes> <secs>\n", argv[0]);
		return -1;
	}
	
	port = atoi(argv[2]);
	lengthTrans = atoi(argv[3]);
	secs = atoi(argv[4]);

	if ((he=gethostbyname(argv[1])) == NULL) {  // get the host info
		perror("Name resolution error");
	}
	
	if((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) perror("Socket error");
	
	bzero((char *) &serv_addr, sizeof(serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr = *((struct in_addr *)he->h_addr);
	serv_addr.sin_port = htons(port);
	
	if(connect(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0) perror("Connection error");
	
	start_time = return_time();
	
	while(fragment){
	if (lengthTrans <= MAXDATASIZE) {
			fragment = 0;
			sendThis = lengthTrans;
		} else {
			sendThis = MAXDATASIZE;
			lengthTrans = lengthTrans - MAXDATASIZE;
		}
		message = (char *)malloc(sizeof(char)*sendThis);
		if ((numbytes = send(sockfd, message,  sizeof(char)*sendThis, 0)) < 0) perror("Send");;
		free(message);
		printf("sent %d bytes to %s\n", numbytes, inet_ntoa(serv_addr.sin_addr));		
		current_time = return_time();
		if(current_time - start_time > secs){
			printf("End of time.\n");
			break;
		}
	}
	
	close(sockfd);
}
