-- MySQL Administrator dump 1.4
--
-- ------------------------------------------------------
-- Server version	5.0.22-log


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;


--
-- Create schema Maya
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ Maya;
USE Maya;

--
-- Table structure for table `Maya`.`log`
--

DROP TABLE IF EXISTS `log`;
CREATE TABLE `log` (
  `ID` int(10) NOT NULL default '0',
  `parameter` varchar(25) NOT NULL default '',
  `value` varchar(30) NOT NULL default '',
  `HIT` varchar(40) NOT NULL default '',
  `ACK` int(1) default '0',
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `Maya`.`log`
--

/*!40000 ALTER TABLE `log` DISABLE KEYS */;
LOCK TABLES `log` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `log` ENABLE KEYS */;


--
-- Table structure for table `Maya`.`router`
--

DROP TABLE IF EXISTS `router`;
CREATE TABLE `router` (
  `IP` varchar(20) NOT NULL default '',
  `active` int(1) NOT NULL default '0',
  `TTL` int(2) NOT NULL default '0',
  `password` varchar(25) NOT NULL default '',
  `HIT` varchar(40) NOT NULL default '',
  PRIMARY KEY  (`IP`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Dumping data for table `Maya`.`router`
--

/*!40000 ALTER TABLE `router` DISABLE KEYS */;
LOCK TABLES `router` WRITE;
UNLOCK TABLES;
/*!40000 ALTER TABLE `router` ENABLE KEYS */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
