#include "sockets.h"
int main(int argc, char *argv[])
{

	struct sockaddr_in their_addr; // connector's address information
	struct hostent *he;
	int sockfd;
	int numbytes;
	int one=1;
	int i,j,k,length;

        RSA *key, *key2;
        FILE *priv_keyfile = NULL;
        unsigned char *tmp = NULL;
        unsigned char array[356] = {0};
        encrypted_packet data;

	//Reset memory
        memset(&data, 0, sizeof(encrypted_packet));
	
	//Prepare the encrypted message
	sprintf(data.message,"%s %s %d",argv[1],argv[2],atoi(argv[3]));

	//Read private key
        if((priv_keyfile = fopen("priv.key", "r")) == NULL){
                fprintf(stderr, "fopen()\n");
                exit(EXIT_FAILURE);
        }

        key = PEM_read_RSAPrivateKey(priv_keyfile, NULL, NULL, NULL);

        fclose(priv_keyfile); 

        tmp = (unsigned char *)&data;
	//Encrypt data
        RSA_private_encrypt(245, tmp, array, key, RSA_PKCS1_PADDING);

        RSA_free(key);

	if ((he=gethostbyname(argv[6])) == NULL) {  // get the host info
		perror("gethostbyname");
		exit(1);
	}

	if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}
	/*Options to allow the socket to allow broadcast*/	
	if (setsockopt(sockfd, SOL_SOCKET,  SO_REUSEADDR, (char *)&one,sizeof(one)) < 0) {
   	 perror("setsockopt() failed");
   	 exit(1);
  	}

	if (setsockopt(sockfd, SOL_SOCKET,  SO_BROADCAST, (char *)&one,sizeof(one)) < 0) {
   	 perror("setsockopt() failed");
   	 exit(1);
  	}

	their_addr.sin_family = AF_INET;	 // host byte order
	their_addr.sin_port = htons(PORT); // short, network byte order
	their_addr.sin_addr = *((struct in_addr *)he->h_addr);
	memset(&(their_addr.sin_zero), '\0', 8);  // zero the rest of the struct

	//Copy the arguments into the packet
	
	j=0;
	i=257;//First valid position after encrypted text
	for(k=4;k<=argc-1;k++){
		length=strlen(argv[k]);
		for(j=0;j<length;j++){
			length=strlen(argv[k]);
			array[i]=argv[k][j];
			i++;
		}
	array[i]=' ';
	i++;
	}
	i--;
	array[i]='\0';


	if ((numbytes = sendto(sockfd, array, 356, 0,
			 (struct sockaddr *)&their_addr, sizeof(struct sockaddr))) == -1) {
		perror("sendto");
		exit(1);
	}


	printf("sent %d bytes to %s\n", numbytes, inet_ntoa(their_addr.sin_addr));

	close(sockfd);

	return 0;
}
