#include "sockets.h"

/*Control Point Process*/
int main(int argc, char *argv[])
{

	struct sockaddr_in their_addr,my_addr; // connector's address information
	struct hostent *he;
	socklen_t addr_len;
	int sockfd,sockfd2,sockfd3;
	int numbytes,numbytes2,numbytes3;
	int one=1;
	int num_seq;
	int select;
	char *myip;
	char aux[16];
	int i,j,k,max_try,length;

	char rec_broadcast_ip[16];	
	char rec_source_ip[16];
	char rec_target_ip[16];
	char rec_param[20];
	char rec_value[50];
	char rec_HIT[42];
	char rec_id[10];

	char HIT[42];
	int rec_num_seq;
	char *rec_num_seqs;
	char myHIT[42];
	char tmp1[200];

        RSA *key, *key2;
        FILE *priv_keyfile = NULL;
	FILE *pub_keyfile = NULL;
	FILE *HIT_file = NULL;
        unsigned char *tmp = NULL;
        unsigned char array[356] = {0};
        unsigned char array2[356] = {0};
	unsigned char unencrypted_data[100] = {0};
	unsigned char unencrypted_string[100] = {0};
        encrypted_packet data,data2;

/////////////////////////////////////////////////////////////////
	

	num_seq=atoi(argv[4]);


	//We get our wlan IP
	get_wlan_ip(aux);	
	myip=strtok(aux,"\n");


        memset(&data, 0, sizeof(encrypted_packet));

	//Prepare the encrypted part of the message
	sprintf(data.message,"%s %s %d",argv[1],argv[2],atoi(argv[3]));

	//Read private key and encrypts the message
        if((priv_keyfile = fopen("priv.key", "r")) == NULL){
                fprintf(stderr, "fopen()\n");
                exit(EXIT_FAILURE);
        }
        key = PEM_read_RSAPrivateKey(priv_keyfile, NULL, NULL, NULL);
        fclose(priv_keyfile); 
        tmp = (unsigned char *)&data;
        RSA_private_encrypt(245, tmp, array, key, RSA_PKCS1_PADDING);
        RSA_free(key);


	//SOCKET SENDER
	if ((he=gethostbyname(argv[6])) == NULL) {  // get the host info
		perror("gethostbyname");
		exit(1);
	}

	if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}
	
	/*Options to allow the socket to allow broadcast*/	
	if (setsockopt(sockfd, SOL_SOCKET,  SO_REUSEADDR, (char *)&one,sizeof(one)) < 0) {
   	 perror("setsockopt() failed");
   	 exit(1);
  	}
	if (setsockopt(sockfd, SOL_SOCKET,  SO_BROADCAST, (char *)&one,sizeof(one)) < 0) {
   	 perror("setsockopt() failed");
   	 exit(1);
  	}
	their_addr.sin_family = AF_INET;	 // host byte order
	their_addr.sin_port = htons(PORT); // short, network byte order
	their_addr.sin_addr = *((struct in_addr *)he->h_addr);
	memset(&(their_addr.sin_zero), '\0', 8);  // zero the rest of the struct

	
	//Copy the arguments into the packet
	j=0;
	i=257;//First valid position after encrypted text
	for(k=4;k<=argc-1;k++){
		length=strlen(argv[k]);
		for(j=0;j<length;j++){
			array[i]=argv[k][j];
			i++;
		}
	array[i]=' ';
	i++;
	}
	i--;
	array[i]='\0';

	if ((numbytes = sendto(sockfd, array, 356, 0,
			 (struct sockaddr *)&their_addr, sizeof(struct sockaddr))) == -1) {
		perror("sendto");
		exit(1);
	}


	printf("sent %d bytes to %s\n", numbytes, inet_ntoa(their_addr.sin_addr));

	//SOCKET LISTENER
	if ((sockfd2 = socket(AF_INET, SOCK_DGRAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}
	
	if (setsockopt(sockfd2, SOL_SOCKET,  SO_REUSEADDR, (char *)&one,sizeof(one)) < 0) {
   	 perror("setsockopt() failed");
   	 exit(1);
  	}

	if (setsockopt(sockfd2, SOL_SOCKET,  SO_BROADCAST, (char *)&one,sizeof(one)) < 0) {
   	 perror("setsockopt() failed");
   	 exit(1);
  	}

	my_addr.sin_family = AF_INET;		 // host byte order
	my_addr.sin_port = htons(PORT);	 // short, network byte order
	my_addr.sin_addr.s_addr = htonl(INADDR_ANY); // automatically fill with my IP
	memset(&(my_addr.sin_zero), '\0', 8); // zero the rest of the struct

	if (bind(sockfd2, (struct sockaddr *)&my_addr,
		sizeof(struct sockaddr)) == -1) {
		perror("bind");
		exit(1);
	}
	addr_len = sizeof(struct sockaddr);

/*-----------------------------------------------------------------------------*/

	//We store our HIT in myHIT
	if((HIT_file = fopen("HIT", "r")) == NULL){
        fprintf(stderr, "fopen()\n");
        exit(EXIT_FAILURE);
	}
	fgets(myHIT,41,HIT_file);
	
	max_try=0;
	while (1){
	//Waiting for ACK...	
        select=input_timeout(sockfd2, WAIT_TIME);
	if (select==1){//If we recieve a packet...
		if ((numbytes2 = recvfrom(sockfd2, array2, 356 , 0,
			(struct sockaddr *)&their_addr, &addr_len)) == -1) {
			perror("recvfrom");
			exit(1);
		}
		//...we get the public key of the AP to read the packet        	
		if((pub_keyfile = fopen(argv[7], "r")) == NULL){
                	fprintf(stderr, "fopen()\n");
                	exit(EXIT_FAILURE);

        	}
       		key=PEM_read_RSAPublicKey(pub_keyfile, NULL, NULL, NULL);
        	fclose(pub_keyfile); 

        	memset(&data2, 0, sizeof(encrypted_packet));

		//We get the unencrypted part of the packet
		j=0;
		for(i=257;i<356 && array2[i]!='\0';i++){
			unencrypted_data[j]=array2[i];
			j++;
		}
		unencrypted_data[j]='\0';
		printf ("DATA RECIEVED:%s\n",unencrypted_data);
		
		//We get the sequence number and the rest of values
		strcpy(tmp1,unencrypted_data);
		rec_num_seqs=strtok(tmp1," ");
		rec_num_seq=atoi(rec_num_seqs);
	
		sscanf(unencrypted_data,"%*s %s %s %s",rec_source_ip,rec_broadcast_ip,rec_HIT);

        	RSA_public_decrypt(256, array2, (unsigned char *)&data2 , key, RSA_PKCS1_PADDING);
        	RSA_free(key);


	}
	//If not ACK recieved (select=0) we retry...
  	else {	        

		num_seq++;
		memset(&data, 0, sizeof(encrypted_packet));
		sprintf(data.message,"%s %s %d",argv[1],argv[2],atoi(argv[3]));

		max_try++;	

		their_addr.sin_port = htons(PORT); // short, network byte order
		if((priv_keyfile = fopen("priv.key", "r")) == NULL){
                	fprintf(stderr, "fopen()\n");
                	exit(EXIT_FAILURE);
        	}

        	key = PEM_read_RSAPrivateKey(priv_keyfile, NULL, NULL, NULL);

        	fclose(priv_keyfile); 

        	tmp = (unsigned char *)&data;
        	RSA_private_encrypt(245, tmp, array, key, RSA_PKCS1_PADDING);

        	RSA_free(key);

		sprintf(unencrypted_string,"%d %s %s %s",num_seq,argv[5],argv[6],argv[7]);
		printf("STRING:%s\n",unencrypted_string);
		j=0;
		i=257;//First valid position after encrypted text
		for(i=257;i<257+strlen(unencrypted_string);i++){
			array[i]=unencrypted_string[j];
			j++;
		}

		if ((numbytes = sendto(sockfd, array, 356, 0,
			(struct sockaddr *)&their_addr, sizeof(struct sockaddr))) == -1) {
			perror("sendto");
			exit(1);
		}
	}
	//...until three times
	if(max_try>=NUM_MAX_TRY) return 0;
	if(select==1){//We verify is the ACK we were waiting for
		sscanf (data2.message,"%s %s %s",rec_param,rec_value,rec_id);
		if(strcmp(rec_param,argv[1])==0 && strcmp(rec_value,argv[2])==0 && strcmp(rec_id,argv[3])==0 && strcmp(rec_HIT,myHIT)==0){
			printf("ACK recieved\n");
			exit(2);//2: ends ok
		}
		else printf("NOT ACK\n");
	}
}return 0;

}
